/******************************************************************************
** Copyright (c) 2013-2016 Intel Corporation All Rights Reserved
**
** Licensed under the Apache License, Version 2.0 (the "License"); you may not
** use this file except in compliance with the License.
**
** You may obtain a copy of the License at
**     http://www.apache.org/licenses/LICENSE-2.0
**
** Unless required by applicable law or agreed to in writing, software
** distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
** WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
**
** See the License for the specific language governing permissions and
** limitations under the License.
**
******************************************************************************/

#pragma once

#include "Dptf.h"
#include "PolicyServicesInterfaceContainer.h"
#include "DomainProperties.h"
#include "ConfigTdpControlSet.h"
#include "CachedProperty.h"
#include "DomainProperty.h"

class dptf_export ConfigTdpControlSetCachedProperty : public CachedProperty, DomainProperty
{
public:

    ConfigTdpControlSetCachedProperty(
        UIntN participantIndex,
        UIntN domainIndex,
        const DomainProperties& domainProperties,
        const PolicyServicesInterfaceContainer& policyServices);
    ~ConfigTdpControlSetCachedProperty();

    const ConfigTdpControlSet& getControlSet();
    virtual Bool supportsProperty() override;

protected:

    virtual void refreshData() override;

    Bool implementsConfigTdpControlInterface();

private:

    ConfigTdpControlSet m_configTdpControlSet;
};